//
//
//	DXF file lexer class
//
//											(C) 1997 JoOl


#ifndef _DXF_LEXER_H_
#define _DXF_LEXER_H_

#include "LexerText.h"



// Tokens in DXF files
enum
{
	LX_TOKEN_SECTION = 0x100,
		LX_TOKEN_HEADER,
			LX_TOKEN_S_ACADVER,
		LX_TOKEN_TABLES,
			LX_TOKEN_TABLE,
				LX_TOKEN_APPID,
//				LX_TOKEN_DIMSTYLE,
//				LX_TOKEN_LTYPE,
				LX_TOKEN_LAYER,
//				LX_TOKEN_STYLE,
//				LX_TOKEN_UCS,
				LX_TOKEN_VIEW,
//				LX_TOKEN_VPORT,
			LX_TOKEN_ENDTAB,
		LX_TOKEN_BLOCKS,
		LX_TOKEN_ENTITIES,
			LX_TOKEN_LINE,
			LX_TOKEN_POINT,
			LX_TOKEN_VERTEX,
			LX_TOKEN_3DFACE,
			LX_TOKEN_POLYLINE,
			LX_TOKEN_SEQEND,
	LX_TOKEN_ENDSEC,
	LX_TOKEN_EOF
};



class					LexerDxf : public LexerText
{

	void				SetCharset();
	void				SetLexemes();

	bool				ReadLine();

	int32				GroupCode;

public:

	LexerDxf(int32, int32);
	~LexerDxf();

	int32				GetGroupCode()
	{ return GroupCode;	};

	virtual bool		NextToken(uint32& );
};



#endif	/* _DXF_LEXER_H_ */

