//
//
//	OBJ file parser class
//
//											(C) 1997 JoOl


#ifndef _OBJ_PARSER_H_
#define _OBJ_PARSER_H_


#include "ParserText.h"
#include "LexerObj.h"


class						ParserObj: public ParserText
{
	int32					DegU, DegV;
	int32					StepU, StepV;

#define INT32_NO_VALUE		0x80000000

	bool					ParseVector1or2or3(float& , float& , float& );
	bool					ParseVector3(float& , float& , float& );
	bool					ParseVector3or4(float& , float& , float& , float& );
	bool					ParseTriplet(int32& , int32& , int32& );
	void					PrintTriplet(int32, int32, int32);

	bool					ParseVertex();
	bool					ParseVtexture();
	bool					ParseVnormal();
	bool					ParseVparam();

	bool					ParseCurveOrSurface();
	bool					ParseCsType(int32& );
	bool					ParseCsDegree(int32& , int32& );
	bool					ParseMatrix(int32);
	bool					ParseSteps(int32& , int32& );
		bool					ParseParam();
		bool					ParseTrim();
		bool					ParseHole();
		bool					ParseScurve();
		bool					ParseSpoints();
		bool					ParseConnect();

	bool					ParsePoint();
	bool					ParseLine();
	bool					ParseFace();
	bool					ParseCurve();
	bool					ParseCurve2d();
	bool					ParseSurface();

	bool					ParseGroup();
	bool					ParseSmoothGroup();
	bool					ParseMergeGroup();
	bool					ParseObjectName();

	bool					ParseBevelInterpol();
	bool					ParseCinterp();
	bool					ParseDinterp();
	bool					ParseLod();
	bool					ParseMapLib();
	bool					ParseUseMap();
	bool					ParseUseMaterial();
	bool					ParseMaterialLib();
	bool					ParseShadow();
	bool					ParseTrace();
	bool					ParseCtech();
	bool					ParseStech();

	bool					ParseBsp();
	bool					ParseBzp();
	bool					ParseCdc();
	bool					ParseCdp();
	bool					ParseRes();

	bool					ParseSwitch();

public:

	ParserObj(bool, int32 = LEXER_BUFLEN, int32 = LEXER_LEXMLEN);
	~ParserObj();

	virtual bool			CheckType();
	virtual bool			Parse();
};


#endif	/* _OBJ_PARSER_H_ */

