//
//
//	File parser basic class
//
//											(C) 1997 JoOl


#ifndef _PARSER_H_
#define _PARSER_H_


#include "Lexer.h"


enum
{
	BIT00 = (1 << 0),
	BIT01 = (1 << 1),
	BIT02 = (1 << 2),
	BIT03 = (1 << 3),
	BIT04 = (1 << 4),
	BIT05 = (1 << 5),
	BIT06 = (1 << 6),
	BIT07 = (1 << 7),
	BIT08 = (1 << 8),
	BIT09 = (1 << 9),
	BIT10 = (1 << 10),
	BIT11 = (1 << 11),
	BIT12 = (1 << 12),
	BIT13 = (1 << 13),
	BIT14 = (1 << 14),
	BIT15 = (1 << 15),
	BIT16 = (1 << 16),
	BIT17 = (1 << 17),
	BIT18 = (1 << 18),
	BIT19 = (1 << 19),
	BIT20 = (1 << 20),
	BIT21 = (1 << 21),
	BIT22 = (1 << 22),
	BIT23 = (1 << 23),
	BIT24 = (1 << 24),
	BIT25 = (1 << 25),
	BIT26 = (1 << 26),
	BIT27 = (1 << 27),
	BIT28 = (1 << 28),
	BIT29 = (1 << 29),
	BIT30 = (1 << 30),
	BIT31 = (1 << 31)
};



class						Parser
{

#define MAX_PARSE_DEPTH		64


#define ASSERT(f)				\
		Indent -= 2;			\
		if (!(f))				\
		{						\
			Indent += 2;		\
			return false;		\
		}						\
		else					\
			Indent += 2


#define ASSERT2(f, g)	PRINT0(g " in\n");			\
						Indent -= 2;				\
						if (!f)						\
						{							\
							Indent += 2;			\
							PRINT0(g " failed\n");	\
							return false;			\
						}							\
						else						\
						{							\
							Indent += 2;			\
							PRINT0(g " out\n");		\
						}

protected:

	bool					Verbose;

	// Used for verbose mode only
	char					Spaces[MAX_PARSE_DEPTH+1];
	char*					Indent;

	Symbol*					SearchSymbol(char* );
	void					PrintSymbol(Symbol* );

	void					InitIndent();


#define _PRINT0(s)								\
			if (Verbose)						\
				printf(s)

#define _PRINT1(s, a)							\
			if (Verbose)						\
				printf(s, a)

#define _PRINT2(s, a, b)						\
			if (Verbose)						\
				printf(s, a, b)

#define _PRINT3(s, a, b, c)						\
			if (Verbose)						\
				printf(s, a, b, c)

#define _PRINT4(s, a, b, c, d)					\
			if (Verbose)						\
				printf(s, a, b, c, d)

#define _PRINT5(s, a, b, c, d, e)				\
			if (Verbose)						\
				printf(s, a, b, c, d, e)

#define _PRINT6(s, a, b, c, d, e, f)			\
			if (Verbose)						\
				printf(s, a, b, c, d, e, f)

#define _PRINT7(s, a, b, c, d, e, f, g)		\
			if (Verbose)						\
				printf(s, a, b, c, d, e, f, g)

#define _PRINT8(s, a, b, c, d, e, f, g, h)		\
			if (Verbose)						\
				printf(s, a, b, c, d, e, f, g, h)

#define _PRINT9(s, a, b, c, d, e, f, g, h, i)	\
			if (Verbose)						\
				printf(s, a, b, c, d, e, f, g, h, i)

#define _PRINTA(s, a, b, c, d, e, f, g, h, i, j)		\
			if (Verbose)								\
				printf(s, a, b, c, d, e, f, g, h, i, j)

public:

#pragma export on

	Parser(bool );
	~Parser();

	virtual bool			CheckType() = 0;
	virtual bool			Parse() = 0;


#pragma export off

};




#endif	/* _PARSER_H_ */

